//
//  ESCPOS_ViewController.m
//  iOS
//
//  Created by leesk on 11. 11. 9..
//  Copyright 2011. All rights reserved.
//

#import "ESCPOS_ViewController.h"

@implementation ESCPOS_ViewController

@synthesize ipAddressField;
@synthesize openButton;
@synthesize closeButton;
@synthesize sample01_Button;
@synthesize sample02_Button;
@synthesize sample03_Button;
@synthesize sample04_Button;
@synthesize sample05_Button;
@synthesize sample06_Button;
@synthesize sample07_Button;
@synthesize sample08_Button;
 
/*
// The designated initializer. Override to perform setup that is required before the view is loaded.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/


/*
// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
}
*/


/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/


- (void) uiToggle:(UIButton*) uiObj mode:(BOOL) mode
{
	if(mode)
	{
		[uiObj setEnabled:TRUE];
		[uiObj setTitleColor:RGB(50,79,133) forState:UIControlStateNormal];
	}
	else
	{
		[uiObj setEnabled:FALSE];
		[uiObj setTitleColor:[UIColor grayColor] forState:UIControlStateNormal];	
	}
}

- (void) setUIConnected:(BOOL) isConnected
{
	// if connected.
	if(isConnected)
	{
		[ipAddressField setEnabled:FALSE];
		[self uiToggle:openButton mode:FALSE ];
		[self uiToggle:closeButton mode:TRUE];	
		[self uiToggle:sample01_Button mode:TRUE];
		[self uiToggle:sample02_Button mode:TRUE];
		[self uiToggle:sample03_Button mode:TRUE];
		[self uiToggle:sample04_Button mode:TRUE];
		[self uiToggle:sample05_Button mode:TRUE];
		[self uiToggle:sample06_Button mode:TRUE];
		[self uiToggle:sample07_Button mode:TRUE];
		[self uiToggle:sample08_Button mode:TRUE];
	}
	else
	{
		[ipAddressField setEnabled:TRUE];	
		[self uiToggle:openButton mode:TRUE];
		[self uiToggle:closeButton mode:FALSE];	
		[self uiToggle:sample01_Button mode:FALSE];
		[self uiToggle:sample02_Button mode:FALSE];
		[self uiToggle:sample03_Button mode:FALSE];
		[self uiToggle:sample04_Button mode:FALSE];
		[self uiToggle:sample05_Button mode:FALSE];
		[self uiToggle:sample06_Button mode:FALSE];
		[self uiToggle:sample07_Button mode:FALSE];
		[self uiToggle:sample08_Button mode:FALSE];
	}
}

- (void) messageBox:(NSString *) message withTitle:(NSString *) title
{
	UIAlertView * alert = [[UIAlertView alloc] initWithTitle:title message:message delegate:nil cancelButtonTitle:@"OK" otherButtonTitles:nil,nil];
	[alert show];
	[alert release];
}

- (IBAction)connectCommand:(id)sender 
{
    NSLog(@"Connect call\r\n");
    long errCode = 0;

    NSString * ip = [ipAddressField text];
	if((errCode = [escp openPort:ip withPortParam:9100]) >= 0)
	{
		[self setUIConnected:TRUE];
		NSLog(@"Connection Established\r\n");
    }
	else if(errCode == -3)
	{
		NSLog(@"ERROR: Invalid device\r\n");
	}
	else
	{
		NSLog(@"ERROR: Connection error\r\n");
	}

}

- (IBAction) disconnectCommand: (id) sender 
{
	[escp closePort];
	NSLog(@"Disconnect call\r\n");
	[self setUIConnected:FALSE];
}

// Receipt
- (IBAction) sample01Proc:(id) sender;
{
	// Command -- Font Size, Alignment
	unsigned char normalSize[3] = {0x1D,0x21,0x00};
	unsigned char dWidthSize[3] = {0x1D,0x21,0x10};
	unsigned char centerAlign[3] = {0x1B,0x61,0x01};
	unsigned char rightAlign[3] = {0x1B,0x61,0x02};
	
	// read the reference manual enclosed the compressed file.
	NSString* barCodeData = @"2132132132131";
	unsigned char barCode128[4] = {0x1D,0x6B,0x73,[barCodeData length]};
	unsigned char barCodeWidth[3] = {0x1D,0x77,0x03};
	unsigned char barCodeHeight[3] = {0x1D,0x68,0x85};
	unsigned char barCodeHRI[3] = {0x1D,0x48,0x02};

    int nLen;
//    NSString * notUTF = @"123아이폰)";
//    unsigned char setUTF8[3] = {0x1B,0x58,0x01};
    NSString * notUTF = @"The euro sign €, and some umlauts ÄÖÜ\r\n";
    const unsigned char * nowUTF;
    //    NSString *nowUTF = [NSString stringWithUTF8String:[notUTF cStringUsingEncoding:NSUTF8StringEncoding]];
    //    NSString *escaped = [original stringByAddingPercentEscapesUsingEncoding:NSUTF8StringEncoding];
    
//    nowUTF = (unsigned char *)[notUTF UTF8String];
    nowUTF = (unsigned char *)[notUTF cStringUsingEncoding:NSWindowsCP1252StringEncoding];
//    [escp printString:nowUTF];
    nLen = strlen((char *)nowUTF);
    NSLog(@"nowUTF size = %d", nLen);
    for(int i=0; i<nLen; i++)
    {
        NSLog(@"%d = %x", i, nowUTF[i]);
    }
    
//    [escp printData:setUTF8 withLength:sizeof(setUTF8)];
    [escp printData:(unsigned char *)nowUTF withLength:strlen((char *)nowUTF)];

	[escp printNVBitmap:1 withAlignment:ALIGNMENT_RIGHT withSize:BITMAP_NORMAL];
	[escp printData:dWidthSize withLength:sizeof(dWidthSize)];				   
	[escp printData:centerAlign withLength:sizeof(centerAlign)];				   
	[escp printString:@"Receipt\r\n\r\n"];
	
	[escp printData:normalSize withLength:sizeof(normalSize)];				   
	[escp printData:rightAlign withLength:sizeof(rightAlign)];				   
	[escp printString:@"TEL (123)-456-7890\r\n"];
	
	[escp printData:centerAlign withLength:sizeof(centerAlign)];				   
	[escp printString:@"Thank you for coming to our shop!\r\n\r\n"];
	
	[escp printString:@"Chicken                   $10.00\r\n"];
	[escp printString:@"Hamburger                 $20.00\r\n"];
	[escp printString:@"Pizza                     $30.00\r\n"];
	[escp printString:@"Lemons                    $40.00\r\n"];
	[escp printString:@"Drink                     $50.00\r\n"];
	[escp printString:@"Excluded tax             $150.00\r\n\r\n"];
	
	[escp printData:rightAlign withLength:sizeof(rightAlign)];				   
	[escp printString:@"Tax(5%)                    $7.50\r\n"];
	[escp printString:@"Total                    $157.50\r\n"];
	[escp printString:@"Payment                  $200.00\r\n"];
	[escp printString:@"Change                    $42.50\r\n\r\n\r\n"];
	
	[escp printData:centerAlign withLength:sizeof(centerAlign)];				   
	[escp printData:barCodeWidth withLength:sizeof(barCodeWidth)];
	[escp printData:barCodeHeight withLength:sizeof(barCodeHeight)];
	[escp printData:barCodeHRI withLength:sizeof(barCodeHRI)];
	[escp printData:barCode128 withLength:sizeof(barCode128)];
	[escp printString:barCodeData];
	
    // 4 Line Feed
	[escp lineFeed:4];
}

// Receipt -- printText() 
- (IBAction) sample02Proc:(id) sender
{
	unsigned char centerAlign[3] = {0x1B,0x61,0x01};
	
	// read the reference manual enclosed the compressed file.
	NSString* barCodeData = @"21321321321313321";
	
	// pre-saved image data : 1-255
	//[escp printNVBitmap:1 withAlignment:ALIGNMENT_CENTER withSize:BITMAP_NORMAL];
	
	[escp printText:@"Receipt\r\n\r\n" withAlignment:ALIGNMENT_CENTER withOption:FNT_DEFAULT withSize:(TXT_2WIDTH|TXT_2HEIGHT)];	
	[escp printText:@"TEL (123)-456-7890\r\n" withAlignment:ALIGNMENT_RIGHT withOption:FNT_FONTB withSize:TXT_1WIDTH];
	
	[escp printText:@"Thank you for coming to our shop!\r\n\r\n" withAlignment:ALIGNMENT_CENTER withOption:FNT_BOLD withSize:TXT_1WIDTH];
	
	[escp printData:centerAlign withLength:sizeof(centerAlign)];				   
	[escp printString:@"Chicken                   $10.00\r\n"];
	[escp printString:@"Hamburger                 $20.00\r\n"];
	[escp printString:@"Pizza                     $30.00\r\n"];
	[escp printString:@"Lemons                    $40.00\r\n"];
	[escp printString:@"Drink                     $50.00\r\n"];
	[escp printString:@"Excluded tax             $150.00\r\n\r\n"];	
	
	[escp printText:@"Tax(5%)         $7.50\r\n" withAlignment:ALIGNMENT_RIGHT withOption:(FNT_FONTB|FNT_UNDERLINE) withSize:(TXT_1WIDTH)];
	[escp printText:@"Total           $157.50\r\n" withAlignment:ALIGNMENT_RIGHT withOption:(FNT_FONTB|FNT_UNDERLINE) withSize:(TXT_1WIDTH)];
	[escp printText:@"Payment         $200.00\r\n" withAlignment:ALIGNMENT_RIGHT withOption:(FNT_FONTB|FNT_UNDERLINE) withSize:(TXT_1WIDTH)];
	[escp printText:@"Change      $42.50\r\n\r\n\r\n" withAlignment:ALIGNMENT_CENTER withOption:(FNT_UNDERLINE) withSize:(TXT_1WIDTH|TXT_2HEIGHT)];
	
	[escp printBarCode:barCodeData withSymbology:BCS_CODE128 withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	
	// 4 Line Feed
	[escp lineFeed:4];
}


- (IBAction) barcode1DTestProc:(id) sender
{
	NSString * barCodeData = @"123456789012";
	
	[escp printString:@"UPCA\r\n"];
	[escp printBarCode:barCodeData withSymbology:BCS_UPCA withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"UPCE\r\n"];
	[escp printBarCode:barCodeData withSymbology:BCS_UPCE withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"EAN8\r\n"];
	[escp printBarCode:@"1234567" withSymbology:BCS_EAN8 withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"EAN13\r\n"];
	[escp printBarCode:barCodeData withSymbology:BCS_EAN13 withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"CODE39\r\n"];
	[escp printBarCode:@"ABCDEFGHI" withSymbology:BCS_CODE39 withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"ITF\r\n"];
	[escp printBarCode:barCodeData withSymbology:BCS_ITF withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"CODABAR\r\n"];
	[escp printBarCode:barCodeData withSymbology:BCS_CODABAR withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"CODE93\r\n"];
	[escp printBarCode:barCodeData withSymbology:BCS_CODE93 withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp printString:@"CODE128\r\n"];
	[escp printBarCode:@"{BNo.{C4567890120" withSymbology:BCS_CODE128 withHeight:70 withWidth:BCS_3WIDTH withAlignment:ALIGNMENT_CENTER withHRI:HRI_TEXT_BELOW];
	[escp lineFeed:3];
}

- (IBAction) BitmapTestProc:(id) sender
{
	
	NSString * imgfile1 = [[NSBundle mainBundle] pathForResource:@"sample_1.jpg" ofType:nil];
	NSString * imgfile2 = [[NSBundle mainBundle] pathForResource:@"sample_2.jpg" ofType:nil];
	NSString * imgfile3 = [[NSBundle mainBundle] pathForResource:@"sample_3.jpg" ofType:nil];
	NSString * imgfile4 = [[NSBundle mainBundle] pathForResource:@"sample_4.jpg" ofType:nil];

	[escp printBitmap:imgfile1 withAlignment:ALIGNMENT_CENTER withSize:BITMAP_NORMAL withBrightness:5];
	[escp printBitmap:imgfile2 withAlignment:ALIGNMENT_LEFT withSize:BITMAP_NORMAL withBrightness:5];
	[escp printBitmap:imgfile3 withAlignment:ALIGNMENT_RIGHT withSize:BITMAP_NORMAL withBrightness:5];
	
	[escp printBitmap:imgfile4 withAlignment:ALIGNMENT_LEFT withSize:BITMAP_QUADRUPLE withBrightness:0];
	[escp printBitmap:imgfile4 withAlignment:ALIGNMENT_LEFT withSize:BITMAP_DOUBLE_WIDTH withBrightness:10];
	
	[escp lineFeed:5];
}

- (IBAction) LogoTestProc:(id) sender
{
	// pre-saved image data : 1-255
	[escp printNVBitmap:1 withAlignment:ALIGNMENT_CENTER withSize:BITMAP_NORMAL];
	[escp lineFeed:3];
}

- (IBAction) pdf417TestProc:(id) sender
{
	NSString * barCodeData = @"ABCDEFGHIJKLMN";
	int length = (int)[barCodeData length];

	
	[escp printString:@"PDF417 Column=3 , Cell Width = 2\r\n"];
	[escp printPDF417:barCodeData withLength:length withColumns:3 withCellWidth:2 withAlignment:ALIGNMENT_CENTER];
	[escp printString:@"PDF417 Column=4 , Cell Width = 2\r\n"];
	[escp printPDF417:barCodeData withLength:length withColumns:4 withCellWidth:2 withAlignment:ALIGNMENT_CENTER];
	[escp printString:@"PDF417 Column=5 , Cell Width = 2\r\n"];
	[escp printPDF417:barCodeData withLength:length withColumns:5 withCellWidth:2 withAlignment:ALIGNMENT_CENTER];
	[escp printString:@"PDF417 Column=6 , Cell Width = 2\r\n"];
	[escp printPDF417:barCodeData withLength:length withColumns:6 withCellWidth:2 withAlignment:ALIGNMENT_CENTER];
	[escp printString:@"PDF417 Column=7 , Cell Width = 2\r\n"];
	[escp printPDF417:barCodeData withLength:length withColumns:7 withCellWidth:2 withAlignment:ALIGNMENT_CENTER];
	[escp printString:@"PDF417 Column=8 , Cell Width = 2\r\n"];
	[escp printPDF417:barCodeData withLength:length withColumns:8 withCellWidth:2 withAlignment:ALIGNMENT_CENTER];


	[escp printString:@"PDF417 Column=4 , Cell Width = 1\r\n"];
	[escp printPDF417:barCodeData withLength:length withColumns:4 withCellWidth:1 withAlignment:ALIGNMENT_LEFT];
	[escp printString:@"PDF417 Column=4 , Cell Width = 5\r\n"];
	[escp printPDF417:barCodeData withLength:length withColumns:4 withCellWidth:5 withAlignment:ALIGNMENT_CENTER];
	[escp printString:@"PDF417 Column=1 , Cell Width = 6\r\n"];
	[escp printPDF417:barCodeData withLength:length withColumns:1 withCellWidth:6 withAlignment:ALIGNMENT_RIGHT];
	[escp lineFeed:3];
}

- (IBAction) qrcodeTestProc:(id) sender
{
	NSString * barCodeData = @"ABCDEFGHIJKLMN";
	int length = (int)[barCodeData length];

	[escp printString:@"QR Left Alignment\r\n"];
	[escp printQRCode:barCodeData withLength:length withModuleSize:3 withECLevel:0 withAlignment:ALIGNMENT_LEFT];
	[escp printString:@"QR Center Alignment\r\n"];
	[escp printQRCode:barCodeData withLength:length withModuleSize:3 withECLevel:0 withAlignment:ALIGNMENT_CENTER];
	[escp printString:@"QR Right Alignment\r\n"];
	[escp printQRCode:barCodeData withLength:length withModuleSize:3 withECLevel:0 withAlignment:ALIGNMENT_RIGHT];
	[escp lineFeed:3];
}


- (IBAction) printerCheckProc:(id) sender
{
	long sts = [escp  printerCheck];
	NSString * result = @"";
	
	NSLog(@"Status value : %ld",sts);
	if([escp asbMode])
		return;
	
	if(sts == STS_NORMAL)
	{
		[self messageBox:@"Normal" withTitle:@"Printer Status"];
	}
	else
	{
		if((sts & STS_COVEROPEN) > 0)
		{
			result = [result stringByAppendingString:@"Cover Open\r\n"];
		}
		if((sts & STS_PAPEREMPTY) > 0)
		{
			result = [result stringByAppendingString:@"Paper Empty\r\n"];
		}
		[self messageBox:result withTitle:@"Printer Status"];
	}
}

// Korean Test - CharSet
- (IBAction) KORCharSetTestProc:(id) sender
{
	unsigned char leftAlign[] = "\x1B\x61\x00";
	unsigned char normalSize[] = "\x1D\x21\x00";
	unsigned char doubleSize[] = "\x1D\x21\x11";
	unsigned char dWidthSize[] = "\x1D\x21\x10";
	
	NSString * stringToSend = @"한글 ";
	NSString * stringToSend2 = @"한 TEST\r\n\r\n";
	
	// Encoding - Korean  
	char * dataToSend = (char *) [stringToSend cStringUsingEncoding:0x80000940];
	// Encoding - English
	//char * dataToSend = (char *) [stringToSend cStringUsingEncoding:NSASCIIStringEncoding];
	
	// ESCPOS setEncoding. 
	[escp setEncoding:0x80000940];
	
	[escp printData:leftAlign withLength:3];
	[escp printData:doubleSize withLength:3];
	[escp printData:(unsigned char *)dataToSend withLength:(int)strlen(dataToSend)];
	[escp printString:stringToSend2];
	
	[escp printData:dWidthSize withLength:3];
	[escp printData:(unsigned char *)dataToSend withLength:(int)strlen(dataToSend)];
	[escp printString:stringToSend2];
	
	[escp printData:normalSize withLength:3];
	[escp printData:(unsigned char *)dataToSend withLength:(int)strlen(dataToSend)];
    [escp printString:stringToSend2];
	
	[escp printString:@"\r\n\r\n\r\n\r\n"];
}

// TextField input done. - hiding keyboard. 
- (IBAction) textFieldDoneEditing:(id) sender
{
	[sender resignFirstResponder];
}

- (IBAction) backgroundTab:(id) sender
{
	// NSLog(@"pressed");
	[ipAddressField resignFirstResponder];
}

/////////////////////////////////
// run once at App start.
- (void) viewDidLoad 
{
	escp = [[ESCPOSPrinter alloc] init];		
	[self setUIConnected:FALSE];
    [ipAddressField setText:@"192.168.1.246"];
}
////////////////////////////////

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc 
{
	[ipAddressField release];
	[openButton release];
	[closeButton release];
	[sample01_Button release];
	[sample02_Button release];
	[sample03_Button release];
	[sample04_Button release];
	[sample05_Button release];
	[sample06_Button release];
	[sample07_Button release];
	[sample08_Button release];
	[escp release];
    [super dealloc];
}

@end
